// @ myth - client - invent.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef INVENT_HEADER
#define INVENT_HEADER

// @@ include

#include "client/window.h"
#include "common/command.h"
#include "common/page.h"

// @@ const

// Maximum number of symbols in inventory.

// @@ (local) class INVENTORY_SYMBOL

struct INVENTORY_SYMBOL : PAGE
{
    STRING letters;
    void AppendSymbol(PAGE* page, long* arg);
};

// @@ (local) struct INVENTORY_BUNCH

struct INVENTORY_BUNCH
{
    INVENTORY_SYMBOL symbol[SymbolCount];
    char all[SymbolCount + 1];	// List of symbols in inventory
    void create(PAGE* page);	// Create Inventory
    // Show Inventory
    void AppendPage(PAGE* page, symbol_type type, long arg);
    INVENTORY_BUNCH();
};

// @@ class INVENTORY

class INVENTORY : WINDOW
{
    INVENTORY_BUNCH invent[INVENTORY_END];
    bool CoverPage;		// TRUE, iff page should cover the screen
    inventory_type NewBunch;	// New bunch to be displayed in the window
    PAGE page;			// Page of actual objects
    void CreatePage(inventory_type bunch, symbol_type symbol, long arg);
public:
    // Read an inventory from server
    void create(inventory_type bunch, PAGE* page);
    // Show inventory
    void show(inventory_type bunch, symbol_type symbol, long arg);
    void update();
    inline bool check()
    { return CoverPage; }
    inline PAGE* cover()
    { CoverPage = FALSE; return &page; }
    // Special information
    const char* symbol(inventory_type bunch);
    const char* letter(inventory_type bunch, symbol_type symbol);
    INVENTORY();
};    

// @@ end

#endif INVENT_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
