// @ myth - server - hiscore.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef HISCORE_HEADER
#define HISCORE_HEADER

// @@ include

#include "common/common.h"
#include "common/string.h"
#include "common/list.h"

struct BINARY;
struct PAGE;

// @@ SCORE_ENTRY

class SCORE_ENTRY
{
    long MyScore;
    STRING name;
    STRING why;
public:
    long score()
    { return MyScore; }
    STRING print();
    void save(BINARY* binary);
    SCORE_ENTRY(BINARY* binary);
    SCORE_ENTRY(long s, STRING n, STRING w);
};

// @@ HI_SCORE

class HI_SCORE
{
    LIST list;
    long MinScore;
    void reset()
    { list.reset(); }
    void next()
    { list.next(); }
    SCORE_ENTRY* current()
    { return (SCORE_ENTRY*) list.current(); }
    void insert(SCORE_ENTRY* entry)
    { list.insert(entry); }
    void erase();
public:
    void page(PAGE* page);
    void add(SCORE_ENTRY* entry);
    void load(BINARY* binary);
    void save(BINARY* binary);
    HI_SCORE();
    ~HI_SCORE();
};

// @@ end

#endif HISCORE_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
